'use strict';

var paths = {
  js: ['*.js']
};

module.exports = function(grunt) {

  require('time-grunt')(grunt);

  // Project Configuration
  grunt.initConfig({
    pkg: grunt.file.readJSON('package.json'),
    watch: {
      js: {
        files: paths.js,
        options: {
          livereload: true
        }
      }
    },
    nodemon: {
      dev: {
        script: 'restAPI.js',
        options: {
          args: [],
          ignore: ['node_modules/**'],
          ext: 'js',
          nodeArgs: ['--debug'],
          delayTime: 1,
          cwd: __dirname
        }
      }
    },
    concurrent: {
      tasks: ['nodemon', 'watch'],
      options: {
        logConcurrentOutput: true
      }
    }
  });

  //Load NPM tasks
  require('load-grunt-tasks')(grunt);

  //Default task(s).
  grunt.registerTask('default', ['concurrent']);
};
