# MongoDB REST API example

This is a very simple implementation of a MongoDB REST API, using Express and Mongoskin.

## Prerequisites
* Node.js - Download and Install [Node.js](http://www.nodejs.org/download/). You can also follow [this gist](https://gist.github.com/isaacs/579814) for a quick and easy way to install Node.js and npm
* MongoDB - Download and Install [MongoDB](http://docs.mongodb.org/manual/installation/) - Make sure `mongod` is running on the default port (27017).

### Tools Prerequisites
* NPM - Node.js package manage; should be installed when you install node.js.

### Optional [![Built with Grunt](https://cdn.gruntjs.com/builtwith.png)](http://gruntjs.com/)
* Grunt - Download and Install [Grunt](http://gruntjs.com).
```
$ npm install -g grunt-cli
```

## Additional Packages
* Express - Defined as npm module in the [package.json](package.json) file.
* Mongoskin - Defined as npm module in the [package.json](package.json) file.

## Quick Install
  Cd to the directory containing the application. Install additional packages by running

    $ npm install

  We recommend using [Grunt](https://github.com/gruntjs/grunt-cli) to start the server:

    $ grunt

  Alternatively, when not using `grunt` you can run:

    $ node restAPI

## Usage

  The following API functions are available:

* GET /collections/<name> - return all documents in collection <name>
* POST /collections/<name> - insert document or array of documents from request body into collection <name>
* GET /collections/<name>/<id> - return document from collection <name> with \_id equal to <id>
* PUT /collections/<name>/<id> - update document from collection <name> with \_id equal to <id> with data from request body
* DELETE /collections/<name>/<id> - remove document with \_id equal to <id> from collection <name>

One way of testing the API is to use the program curl, like this:

    $ curl -X POST -H 'Content-Type:application/json' -d @fileWithProperJSONData.json http://localhost:3000/collections/cities
